"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.yfmTableCellView = exports.yfmTableCellCn = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const icons_1 = require("@gravity-ui/icons");
const uikit_1 = require("@gravity-ui/uikit");
const prosemirror_utils_1 = require("prosemirror-utils");
const react_dom_1 = require("react-dom");
const classname_1 = require("../../../../../classname");
const core_1 = require("../../../../../core");
const yfm_table_1 = require("../../../../../i18n/yfm-table");
const ErrorBoundary_1 = require("../../../../../react-utils/ErrorBoundary");
const table_utils_1 = require("../../../../../table-utils");
const ReactRenderer_1 = require("../../../../behavior/ReactRenderer");
const actions_1 = require("./actions");
exports.yfmTableCellCn = (0, classname_1.cn)('table-cell-view');
const b = exports.yfmTableCellCn;
const Controls = function Controls({ columnNumber, rowNumber, view, getParentTable, isInFirstRow, isFirstInRow, }) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    const actions = (0, core_1.bindActions)(actions_1.controlActions)(view);
    const controls = [];
    if (isFirstInRow) {
        controls.push(react_1.default.createElement(uikit_1.DropdownMenu, { key: 1, switcherWrapperClassName: b('left-button'), switcher: react_1.default.createElement(uikit_1.Button, { view: 'outlined', size: 's' },
                react_1.default.createElement(uikit_1.Icon, { data: icons_1.EllipsisVertical })), items: [
                {
                    text: (0, yfm_table_1.i18n)('row.add.before'),
                    action: () => {
                        var _a;
                        return actions.appendRow.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            rowNumber,
                            direction: 'before',
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.ArrowUp }),
                    disabled: !actions.appendRow.isEnable({
                        tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                        rowNumber,
                        direction: 'before',
                    }),
                },
                {
                    text: (0, yfm_table_1.i18n)('row.add.after'),
                    action: () => {
                        var _a;
                        return actions.appendRow.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            rowNumber,
                            direction: 'after',
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.ArrowDown }),
                    disabled: !actions.appendRow.isEnable({
                        tablePos: (_b = getParentTable()) === null || _b === void 0 ? void 0 : _b.pos,
                        rowNumber,
                        direction: 'after',
                    }),
                },
                {
                    text: (0, yfm_table_1.i18n)('row.remove'),
                    action: () => {
                        var _a;
                        return actions.deleteRow.run({
                            rowNumber,
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.Xmark }),
                    disabled: !actions.deleteRow.isEnable({
                        rowNumber,
                        tablePos: (_c = getParentTable()) === null || _c === void 0 ? void 0 : _c.pos,
                    }),
                },
                {
                    theme: 'danger',
                    text: (0, yfm_table_1.i18n)('table.remove'),
                    action: () => {
                        var _a, _b;
                        return actions.deleteTable.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            tableNode: (_b = getParentTable()) === null || _b === void 0 ? void 0 : _b.node,
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.TrashBin }),
                    disabled: !actions.deleteTable.isEnable({
                        tablePos: (_d = getParentTable()) === null || _d === void 0 ? void 0 : _d.pos,
                        tableNode: (_e = getParentTable()) === null || _e === void 0 ? void 0 : _e.node,
                    }),
                },
            ] }));
    }
    if (isInFirstRow) {
        controls.push(react_1.default.createElement(uikit_1.DropdownMenu, { key: 2, switcherWrapperClassName: b('upper-button'), switcher: react_1.default.createElement(uikit_1.Button, { view: 'outlined', size: 's' },
                react_1.default.createElement(uikit_1.Icon, { data: icons_1.EllipsisVertical })), items: [
                {
                    text: (0, yfm_table_1.i18n)('column.add.before'),
                    action: () => {
                        var _a;
                        return actions.appendColumn.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            columnNumber,
                            direction: 'before',
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.ArrowLeft }),
                    disabled: !actions.appendColumn.isEnable({
                        tablePos: (_f = getParentTable()) === null || _f === void 0 ? void 0 : _f.pos,
                        columnNumber,
                        direction: 'before',
                    }),
                },
                {
                    text: (0, yfm_table_1.i18n)('column.add.after'),
                    action: () => {
                        var _a;
                        return actions.appendColumn.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            columnNumber,
                            direction: 'after',
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.ArrowRight }),
                    disabled: !actions.appendColumn.isEnable({
                        tablePos: (_g = getParentTable()) === null || _g === void 0 ? void 0 : _g.pos,
                        columnNumber,
                        direction: 'after',
                    }),
                },
                {
                    text: (0, yfm_table_1.i18n)('column.remove'),
                    action: () => {
                        var _a;
                        return actions.deleteColumn.run({
                            columnNumber,
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.Xmark }),
                    disabled: !actions.deleteColumn.isEnable({
                        columnNumber,
                        tablePos: (_h = getParentTable()) === null || _h === void 0 ? void 0 : _h.pos,
                    }),
                },
                {
                    theme: 'danger',
                    text: (0, yfm_table_1.i18n)('table.remove'),
                    action: () => {
                        var _a, _b;
                        return actions.deleteTable.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            tableNode: (_b = getParentTable()) === null || _b === void 0 ? void 0 : _b.node,
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.TrashBin }),
                    disabled: !actions.deleteTable.isEnable({
                        tablePos: (_j = getParentTable()) === null || _j === void 0 ? void 0 : _j.pos,
                        tableNode: (_k = getParentTable()) === null || _k === void 0 ? void 0 : _k.node,
                    }),
                },
            ] }));
    }
    return controls.length ? react_1.default.createElement(react_1.default.Fragment, null, controls) : null;
};
const yfmTableCellView = (node, view, getPos) => {
    const dom = document.createElement('td');
    const contentDOM = document.createElement('div');
    const control = document.createElement('span');
    control.setAttribute('style', 'width: 0; height: 0; float: left;');
    dom.setAttribute('style', 'position: relative; overflow: visible;');
    const getParentTable = () => (0, prosemirror_utils_1.findParentNodeClosestToPos)(view.state.doc.resolve(getPos()), table_utils_1.isTableNode);
    const parentTable = getParentTable();
    // @ts-expect-error
    if (!parentTable)
        return {};
    const rowNodes = (0, prosemirror_utils_1.findChildren)(parentTable === null || parentTable === void 0 ? void 0 : parentTable.node, table_utils_1.isTableRowNode);
    const relativeCelPos = getPos() - (parentTable === null || parentTable === void 0 ? void 0 : parentTable.pos);
    const rowNumber = rowNodes.findIndex((_v, i) => {
        var _a;
        return relativeCelPos > rowNodes[i].pos &&
            relativeCelPos < (((_a = rowNodes[i + 1]) === null || _a === void 0 ? void 0 : _a.pos) || Number.MAX_SAFE_INTEGER);
    });
    const parentRow = rowNodes[rowNumber];
    const columnNumber = (0, prosemirror_utils_1.findChildren)(parentRow.node, table_utils_1.isTableCellNode).findIndex((c) => {
        return c.pos === relativeCelPos - parentRow.pos - 2;
    });
    const isFirstInRow = rowNodes.findIndex((r) => r.pos === relativeCelPos - 2) >= 0;
    dom.appendChild(contentDOM);
    dom.appendChild(control);
    const renderItem = (0, ReactRenderer_1.getReactRendererFromState)(view.state).createItem('yfm-table-cell-view', () => (0, react_dom_1.createPortal)(react_1.default.createElement(ErrorBoundary_1.ErrorLoggerBoundary, null,
        react_1.default.createElement(Controls, { columnNumber: columnNumber, rowNumber: rowNumber, isFirstInRow: isFirstInRow, isInFirstRow: rowNumber === 0, getParentTable: getParentTable, view: view })), control));
    contentDOM.setAttribute('data-row-number', String(rowNumber));
    contentDOM.setAttribute('data-col-number', String(columnNumber));
    return {
        dom,
        contentDOM,
        destroy() {
            renderItem.remove();
        },
        ignoreMutation(mutation) {
            return mutation.type === 'childList' && mutation.target === control;
        },
        update(n) {
            const { rows: nRows, cols: nCols } = (0, table_utils_1.getTableDimensions)(n);
            const { rows, cols } = (0, table_utils_1.getTableDimensions)(node);
            return !(rows !== nRows || cols !== nCols);
        },
    };
};
exports.yfmTableCellView = yfmTableCellView;
